%global gohomepath github.com/coredns
%global goipath %{gohomepath}/coredns

Summary:        DNS server written in Go
Name:           coredns
Version:        1.11.1
Release:        2%{?dist}
License:        Apache-2.0
URL:            https://coredns.io
Source0:        https://%{goipath}/archive/v%{version}/%{name}-%{version}.tar.gz
# execute 'go mod vendor' under the source code path can generator vendor package
Source1:        coredns-1.11.1-vendor.tar.gz
Source2:        Corefile
Source3:        coredns.service

Patch0001:      fix-CVE-2024-0874.patch

BuildRequires:  fdupes golang >= 1.20 go-rpm-macros
Provides:       dns_daemon

%description
CoreDNS is a DNS server in Go. It has a plugin architecture for
extending it.
CoreDNS can listen for DNS request coming in over UDP/TCP (RFC 1035),
TLS (RFC 7858) and gRPC (not a standard).

%package extras
Summary:        Extra components for the %{name} package
BuildRequires:  pkgconfig(systemd)
BuildArch:      noarch

Requires:       %{name} = %{version}
Supplements:    %{name}

%description extras
Extra components for the %{name} package, to make %{name} usable in a
non-containerized environment (man pages, configuration, unit file).

%prep
%autosetup -p1 -a1

%build
export GOPATH=$PWD/.gopath
mkdir -p ${GOPATH}/src/%{gohomepath}
ln -sfn $PWD $GOPATH/src/%{goipath}

export CGO_ENABLED=0
export GOFLAGS="-mod=vendor"
%gobuild -o coredns %{goipath}

%install
install -Dpm 0755 coredns %{buildroot}%{_sbindir}/%{name}
ln -s service %{buildroot}%{_sbindir}/rccoredns
install -Dpm 0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/%{name}/Corefile
install -Dpm 0644 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}.service
install -d %{buildroot}/%{_mandir}/man1
install -pm 0644 man/coredns*.1 %{buildroot}/%{_mandir}/man1
install -d %{buildroot}/%{_mandir}/man5
install -pm 0644 man/corefile*.5 %{buildroot}/%{_mandir}/man5
install -d %{buildroot}/%{_mandir}/man7
install -pm 0644 man/coredns-*.7 %{buildroot}/%{_mandir}/man7

%fdupes %{buildroot}/%{_prefix}

%pre extras

%post extras
%systemd_post %{name}.service

%preun extras
%systemd_preun %{name}.service

%postun extras
%systemd_postun %{name}.service

%files
%license LICENSE
%{_sbindir}/coredns

%files extras
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/Corefile
%{_unitdir}/%{name}.service
%{_sbindir}/rccoredns
%{_mandir}/man1/coredns*
%{_mandir}/man5/corefile*
%{_mandir}/man7/coredns-*

%changelog
* Tue Jun 04 2024 jackeyji <jackeyji@tencent.com> - 1.11.1-2
- [Type] security
- [DESC] fix CVE-2024-0874

* Tue Sep 12 2023 jackeyji <jackeyji@tencent.com> - 1.11.1-1
- initial build
